jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1 | #!/bin/bash |
| 2 | # |
| 3 | # Copyright (C) 2007 The Android Open Source Project |
| 4 | # |
| 5 | # Licensed under the Apache License, Version 2.0 (the "License"); |
| 6 | # you may not use this file except in compliance with the License. |
| 7 | # You may obtain a copy of the License at |
| 8 | # |
| 9 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 10 | # |
| 11 | # Unless required by applicable law or agreed to in writing, software |
| 12 | # distributed under the License is distributed on an "AS IS" BASIS, |
| 13 | # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| 14 | # See the License for the specific language governing permissions and |
| 15 | # limitations under the License. |
| 16 | |
| 17 | # Set up prog to be the path of this script, including following symlinks, |
| 18 | # and set up progdir to be the fully-qualified pathname of its directory. |
| 19 | prog="$0" |
Andreas Gampe | deb48a0 | 2014-10-22 00:44:35 -0700 | [diff] [blame] | 20 | args="$@" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 21 | while [ -h "${prog}" ]; do |
| 22 | newProg=`/bin/ls -ld "${prog}"` |
| 23 | newProg=`expr "${newProg}" : ".* -> \(.*\)$"` |
| 24 | if expr "x${newProg}" : 'x/' >/dev/null; then |
| 25 | prog="${newProg}" |
| 26 | else |
| 27 | progdir=`dirname "${prog}"` |
| 28 | prog="${progdir}/${newProg}" |
| 29 | fi |
| 30 | done |
| 31 | oldwd=`pwd` |
| 32 | progdir=`dirname "${prog}"` |
| 33 | cd "${progdir}" |
| 34 | progdir=`pwd` |
| 35 | prog="${progdir}"/`basename "${prog}"` |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 36 | test_dir="test-$$" |
Andreas Gampe | 5a79fde | 2014-08-06 13:12:26 -0700 | [diff] [blame] | 37 | if [ -z "$TMPDIR" ]; then |
| 38 | tmp_dir="/tmp/$USER/${test_dir}" |
| 39 | else |
Andreas Gampe | 34a8a0f | 2016-07-20 21:09:29 -0700 | [diff] [blame] | 40 | tmp_dir="${TMPDIR}/${test_dir}" |
Andreas Gampe | 5a79fde | 2014-08-06 13:12:26 -0700 | [diff] [blame] | 41 | fi |
David Brazdil | 2c27f2c | 2015-05-12 18:06:38 +0100 | [diff] [blame] | 42 | checker="${progdir}/../tools/checker/checker.py" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 43 | export JAVA="java" |
Alex Light | ea1e770 | 2016-07-11 13:39:55 -0700 | [diff] [blame] | 44 | export JAVAC="javac -g -Xlint:-options" |
Nicolas Geoffray | 1a58b7f | 2014-10-06 12:23:04 +0100 | [diff] [blame] | 45 | export RUN="${progdir}/etc/run-test-jar" |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 46 | export DEX_LOCATION=/data/run-test/${test_dir} |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 47 | export NEED_DEX="true" |
Nicolas Geoffray | 1c5b6da | 2016-03-16 10:55:57 +0000 | [diff] [blame] | 48 | export USE_JACK="true" |
Alex Light | b55f1ac | 2016-04-12 15:50:55 -0700 | [diff] [blame] | 49 | export SMALI_ARGS="--experimental" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 50 | |
Tsu Chiang Chuang | 4407e61 | 2012-07-19 16:13:43 -0700 | [diff] [blame] | 51 | # If dx was not set by the environment variable, assume it is in the path. |
| 52 | if [ -z "$DX" ]; then |
| 53 | export DX="dx" |
| 54 | fi |
| 55 | |
Tsu Chiang Chuang | 6674f8a | 2013-01-16 15:41:21 -0800 | [diff] [blame] | 56 | # If jasmin was not set by the environment variable, assume it is in the path. |
| 57 | if [ -z "$JASMIN" ]; then |
| 58 | export JASMIN="jasmin" |
| 59 | fi |
| 60 | |
Andreas Gampe | 8fda9f2 | 2014-10-03 16:15:37 -0700 | [diff] [blame] | 61 | # If smali was not set by the environment variable, assume it is in the path. |
| 62 | if [ -z "$SMALI" ]; then |
| 63 | export SMALI="smali" |
| 64 | fi |
| 65 | |
| 66 | # If dexmerger was not set by the environment variable, assume it is in the path. |
| 67 | if [ -z "$DXMERGER" ]; then |
| 68 | export DXMERGER="dexmerger" |
| 69 | fi |
| 70 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 71 | # If jack was not set by the environment variable, assume it is in the path. |
| 72 | if [ -z "$JACK" ]; then |
| 73 | export JACK="jack" |
| 74 | fi |
| 75 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 76 | # ANDROID_BUILD_TOP is not set in a build environment. |
| 77 | if [ -z "$ANDROID_BUILD_TOP" ]; then |
| 78 | export ANDROID_BUILD_TOP=$oldwd |
| 79 | fi |
| 80 | |
Andreas Gampe | f47fb2f | 2016-06-24 22:30:29 -0700 | [diff] [blame] | 81 | # ANDROID_HOST_OUT is not set in a build environment. |
| 82 | if [ -z "$ANDROID_HOST_OUT" ]; then |
| 83 | export ANDROID_HOST_OUT=${OUT_DIR:-$ANDROID_BUILD_TOP/out/}host/linux-x86 |
| 84 | fi |
| 85 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 86 | # If JACK_CLASSPATH is not set, assume it only contains core-libart. |
| 87 | if [ -z "$JACK_CLASSPATH" ]; then |
Andreas Gampe | f47fb2f | 2016-06-24 22:30:29 -0700 | [diff] [blame] | 88 | export JACK_CLASSPATH="${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-libart-hostdex_intermediates/classes.jack:${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-oj-hostdex_intermediates/classes.jack" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 89 | fi |
| 90 | |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 91 | export JACK="$JACK -g -cp $JACK_CLASSPATH" |
Tsu Chiang Chuang | 6674f8a | 2013-01-16 15:41:21 -0800 | [diff] [blame] | 92 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 93 | info="info.txt" |
| 94 | build="build" |
| 95 | run="run" |
| 96 | expected="expected.txt" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 97 | check_cmd="check" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 98 | output="output.txt" |
| 99 | build_output="build-output.txt" |
David Brazdil | 24128c6 | 2015-05-21 12:06:13 +0100 | [diff] [blame] | 100 | cfg_output="graph.cfg" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 101 | strace_output="strace-output.txt" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 102 | lib="libartd.so" |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 103 | testlib="arttestd" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 104 | run_args="--quiet" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 105 | build_args="" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 106 | |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 107 | quiet="no" |
Nicolas Geoffray | a3d90fb | 2015-03-16 13:55:40 +0000 | [diff] [blame] | 108 | debuggable="no" |
Alex Light | 9d72253 | 2014-07-22 18:07:12 -0700 | [diff] [blame] | 109 | prebuild_mode="yes" |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 110 | target_mode="yes" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 111 | dev_mode="no" |
| 112 | update_mode="no" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 113 | debug_mode="no" |
| 114 | relocate="yes" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 115 | runtime="art" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 116 | usage="no" |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 117 | build_only="no" |
Andreas Gampe | 2fe0792 | 2014-04-21 07:50:39 -0700 | [diff] [blame] | 118 | suffix64="" |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 119 | trace="false" |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 120 | trace_stream="false" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 121 | basic_verify="false" |
| 122 | gc_verify="false" |
| 123 | gc_stress="false" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 124 | strace="false" |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 125 | always_clean="no" |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 126 | never_clean="no" |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 127 | have_dex2oat="yes" |
| 128 | have_patchoat="yes" |
| 129 | have_image="yes" |
Andreas Gampe | c23c9c9 | 2014-10-28 14:47:25 -0700 | [diff] [blame] | 130 | pic_image_suffix="" |
Jeff Hao | dcdc85b | 2015-12-04 14:06:18 -0800 | [diff] [blame] | 131 | multi_image_suffix="" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 132 | android_root="/system" |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 133 | bisection_search="no" |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 134 | suspend_timeout="500000" |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 135 | # By default we will use optimizing. |
| 136 | image_args="" |
Nicolas Geoffray | b76bc78 | 2016-09-14 12:33:34 +0000 | [diff] [blame] | 137 | image_suffix="" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 138 | |
| 139 | while true; do |
| 140 | if [ "x$1" = "x--host" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 141 | target_mode="no" |
TDYa127 | b92bcab | 2012-04-08 00:09:51 -0700 | [diff] [blame] | 142 | DEX_LOCATION=$tmp_dir |
Nicolas Geoffray | 1a58b7f | 2014-10-06 12:23:04 +0100 | [diff] [blame] | 143 | run_args="${run_args} --host" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 144 | shift |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 145 | elif [ "x$1" = "x--quiet" ]; then |
| 146 | quiet="yes" |
| 147 | shift |
Alex Light | eb7c144 | 2015-08-31 13:17:42 -0700 | [diff] [blame] | 148 | elif [ "x$1" = "x--use-java-home" ]; then |
| 149 | if [ -n "${JAVA_HOME}" ]; then |
| 150 | export JAVA="${JAVA_HOME}/bin/java" |
| 151 | export JAVAC="${JAVA_HOME}/bin/javac -g" |
| 152 | else |
| 153 | echo "Passed --use-java-home without JAVA_HOME variable set!" |
| 154 | usage="yes" |
| 155 | fi |
| 156 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 157 | elif [ "x$1" = "x--jvm" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 158 | target_mode="no" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 159 | runtime="jvm" |
Alex Light | bc90d0f | 2016-05-09 16:21:09 -0700 | [diff] [blame] | 160 | image_args="" |
Brian Carlstrom | 01afdba | 2014-10-03 10:28:47 -0700 | [diff] [blame] | 161 | prebuild_mode="no" |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 162 | NEED_DEX="false" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 163 | USE_JACK="false" |
Nicolas Geoffray | 288a4a2 | 2014-10-07 11:02:40 +0100 | [diff] [blame] | 164 | run_args="${run_args} --jvm" |
Alex Light | eb7c144 | 2015-08-31 13:17:42 -0700 | [diff] [blame] | 165 | build_args="${build_args} --jvm" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 166 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 167 | elif [ "x$1" = "x-O" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 168 | lib="libart.so" |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 169 | testlib="arttest" |
Alex Light | faf90b6 | 2016-08-12 14:43:48 -0700 | [diff] [blame] | 170 | run_args="${run_args} -O" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 171 | shift |
| 172 | elif [ "x$1" = "x--dalvik" ]; then |
| 173 | lib="libdvm.so" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 174 | runtime="dalvik" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 175 | shift |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 176 | elif [ "x$1" = "x--no-dex2oat" ]; then |
| 177 | have_dex2oat="no" |
| 178 | shift |
| 179 | elif [ "x$1" = "x--no-patchoat" ]; then |
| 180 | have_patchoat="no" |
| 181 | shift |
| 182 | elif [ "x$1" = "x--no-image" ]; then |
| 183 | have_image="no" |
| 184 | shift |
Nicolas Geoffray | b76bc78 | 2016-09-14 12:33:34 +0000 | [diff] [blame] | 185 | elif [ "x$1" = "x--npic-image" ]; then |
| 186 | pic_image_suffix="-npic" |
Andreas Gampe | c23c9c9 | 2014-10-28 14:47:25 -0700 | [diff] [blame] | 187 | shift |
Jeff Hao | dcdc85b | 2015-12-04 14:06:18 -0800 | [diff] [blame] | 188 | elif [ "x$1" = "x--multi-image" ]; then |
| 189 | multi_image_suffix="-multi" |
| 190 | shift |
Andreas Gampe | c23c9c9 | 2014-10-28 14:47:25 -0700 | [diff] [blame] | 191 | elif [ "x$1" = "x--pic-test" ]; then |
| 192 | run_args="${run_args} --pic-test" |
| 193 | shift |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 194 | elif [ "x$1" = "x--relocate" ]; then |
| 195 | relocate="yes" |
| 196 | shift |
| 197 | elif [ "x$1" = "x--no-relocate" ]; then |
| 198 | relocate="no" |
| 199 | shift |
| 200 | elif [ "x$1" = "x--prebuild" ]; then |
Nicolas Geoffray | 5fd18ba | 2014-10-03 12:08:38 +0100 | [diff] [blame] | 201 | run_args="${run_args} --prebuild" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 202 | prebuild_mode="yes" |
| 203 | shift; |
Richard Uhler | 76f5cb6 | 2016-04-04 13:30:16 -0700 | [diff] [blame] | 204 | elif [ "x$1" = "x--strip-dex" ]; then |
| 205 | run_args="${run_args} --strip-dex" |
| 206 | shift; |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 207 | elif [ "x$1" = "x--debuggable" ]; then |
| 208 | run_args="${run_args} -Xcompiler-option --debuggable" |
Nicolas Geoffray | a3d90fb | 2015-03-16 13:55:40 +0000 | [diff] [blame] | 209 | debuggable="yes" |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 210 | shift; |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 211 | elif [ "x$1" = "x--no-prebuild" ]; then |
Nicolas Geoffray | 5fd18ba | 2014-10-03 12:08:38 +0100 | [diff] [blame] | 212 | run_args="${run_args} --no-prebuild" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 213 | prebuild_mode="no" |
| 214 | shift; |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 215 | elif [ "x$1" = "x--gcverify" ]; then |
| 216 | basic_verify="true" |
| 217 | gc_verify="true" |
| 218 | shift |
| 219 | elif [ "x$1" = "x--gcstress" ]; then |
| 220 | basic_verify="true" |
| 221 | gc_stress="true" |
| 222 | shift |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 223 | elif [ "x$1" = "x--suspend-timeout" ]; then |
| 224 | shift |
| 225 | suspend_timeout="$1" |
| 226 | shift |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 227 | elif [ "x$1" = "x--image" ]; then |
| 228 | shift |
| 229 | image="$1" |
| 230 | run_args="${run_args} --image $image" |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 231 | shift |
Nicolas Geoffray | 92cf83e | 2014-03-18 17:59:20 +0000 | [diff] [blame] | 232 | elif [ "x$1" = "x-Xcompiler-option" ]; then |
| 233 | shift |
| 234 | option="$1" |
| 235 | run_args="${run_args} -Xcompiler-option $option" |
| 236 | shift |
Mathieu Chartier | 769a5ad | 2014-05-18 15:30:10 -0700 | [diff] [blame] | 237 | elif [ "x$1" = "x--runtime-option" ]; then |
| 238 | shift |
| 239 | option="$1" |
| 240 | run_args="${run_args} --runtime-option $option" |
| 241 | shift |
Mathieu Chartier | c0a8a80 | 2014-10-17 15:58:01 -0700 | [diff] [blame] | 242 | elif [ "x$1" = "x--gdb-arg" ]; then |
| 243 | shift |
| 244 | gdb_arg="$1" |
| 245 | run_args="${run_args} --gdb-arg $gdb_arg" |
| 246 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 247 | elif [ "x$1" = "x--debug" ]; then |
| 248 | run_args="${run_args} --debug" |
| 249 | shift |
| 250 | elif [ "x$1" = "x--gdb" ]; then |
| 251 | run_args="${run_args} --gdb" |
| 252 | dev_mode="yes" |
| 253 | shift |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 254 | elif [ "x$1" = "x--strace" ]; then |
| 255 | strace="yes" |
Mathieu Chartier | 2576be2 | 2016-05-24 10:24:53 -0700 | [diff] [blame] | 256 | run_args="${run_args} --timeout 1800 --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 257 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 258 | elif [ "x$1" = "x--zygote" ]; then |
| 259 | run_args="${run_args} --zygote" |
| 260 | shift |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 261 | elif [ "x$1" = "x--interpreter" ]; then |
Nicolas Geoffray | 4650c93 | 2016-05-10 09:13:13 +0000 | [diff] [blame] | 262 | run_args="${run_args} --interpreter" |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 263 | image_suffix="-interpreter" |
| 264 | shift |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 265 | elif [ "x$1" = "x--jit" ]; then |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 266 | image_args="--jit" |
Nicolas Geoffray | b76bc78 | 2016-09-14 12:33:34 +0000 | [diff] [blame] | 267 | image_suffix="-interpreter" |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 268 | shift |
Andreas Gampe | 63fc30e | 2014-10-24 21:58:16 -0700 | [diff] [blame] | 269 | elif [ "x$1" = "x--optimizing" ]; then |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 270 | image_args="-Xcompiler-option --compiler-backend=Optimizing" |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 271 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 272 | elif [ "x$1" = "x--no-verify" ]; then |
Richard Uhler | f4b3487 | 2016-04-13 11:03:46 -0700 | [diff] [blame] | 273 | run_args="${run_args} --no-verify" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 274 | shift |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 275 | elif [ "x$1" = "x--verify-soft-fail" ]; then |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 276 | image_args="--verify-soft-fail" |
Andreas Gampe | 825570c | 2015-07-26 10:26:03 -0700 | [diff] [blame] | 277 | image_suffix="-interp-ac" |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 278 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 279 | elif [ "x$1" = "x--no-optimize" ]; then |
| 280 | run_args="${run_args} --no-optimize" |
| 281 | shift |
| 282 | elif [ "x$1" = "x--no-precise" ]; then |
| 283 | run_args="${run_args} --no-precise" |
| 284 | shift |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 285 | elif [ "x$1" = "x--invoke-with" ]; then |
| 286 | shift |
| 287 | what="$1" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 288 | if [ "x$what" = "x" ]; then |
| 289 | echo "$0 missing argument to --invoke-with" 1>&2 |
| 290 | usage="yes" |
| 291 | break |
| 292 | fi |
Ian Rogers | 0e03367 | 2013-04-19 10:22:46 -0700 | [diff] [blame] | 293 | run_args="${run_args} --invoke-with ${what}" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 294 | shift |
| 295 | elif [ "x$1" = "x--dev" ]; then |
| 296 | run_args="${run_args} --dev" |
| 297 | dev_mode="yes" |
| 298 | shift |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 299 | elif [ "x$1" = "x--build-only" ]; then |
| 300 | build_only="yes" |
| 301 | shift |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 302 | elif [ "x$1" = "x--build-with-javac-dx" ]; then |
| 303 | USE_JACK="false" |
| 304 | shift |
| 305 | elif [ "x$1" = "x--build-with-jack" ]; then |
| 306 | USE_JACK="true" |
| 307 | shift |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 308 | elif [ "x$1" = "x--output-path" ]; then |
| 309 | shift |
| 310 | tmp_dir=$1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 311 | if [ "x$tmp_dir" = "x" ]; then |
| 312 | echo "$0 missing argument to --output-path" 1>&2 |
| 313 | usage="yes" |
| 314 | break |
| 315 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 316 | shift |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 317 | elif [ "x$1" = "x--android-root" ]; then |
| 318 | shift |
| 319 | if [ "x$1" = "x" ]; then |
| 320 | echo "$0 missing argument to --android-root" 1>&2 |
| 321 | usage="yes" |
| 322 | break |
| 323 | fi |
| 324 | android_root="$1" |
| 325 | run_args="${run_args} --android-root $1" |
| 326 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 327 | elif [ "x$1" = "x--update" ]; then |
| 328 | update_mode="yes" |
| 329 | shift |
| 330 | elif [ "x$1" = "x--help" ]; then |
| 331 | usage="yes" |
| 332 | shift |
Andreas Gampe | afbaa1a | 2014-03-25 18:09:32 -0700 | [diff] [blame] | 333 | elif [ "x$1" = "x--64" ]; then |
| 334 | run_args="${run_args} --64" |
Andreas Gampe | 2fe0792 | 2014-04-21 07:50:39 -0700 | [diff] [blame] | 335 | suffix64="64" |
Andreas Gampe | afbaa1a | 2014-03-25 18:09:32 -0700 | [diff] [blame] | 336 | shift |
Sebastien Hertz | 07aaac8 | 2014-07-09 15:59:05 +0200 | [diff] [blame] | 337 | elif [ "x$1" = "x--trace" ]; then |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 338 | trace="true" |
Sebastien Hertz | 07aaac8 | 2014-07-09 15:59:05 +0200 | [diff] [blame] | 339 | shift |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 340 | elif [ "x$1" = "x--stream" ]; then |
| 341 | trace_stream="true" |
| 342 | shift |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 343 | elif [ "x$1" = "x--always-clean" ]; then |
| 344 | always_clean="yes" |
| 345 | shift |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 346 | elif [ "x$1" = "x--never-clean" ]; then |
| 347 | never_clean="yes" |
| 348 | shift |
Andreas Gampe | e21dc3d | 2014-12-08 16:59:43 -0800 | [diff] [blame] | 349 | elif [ "x$1" = "x--dex2oat-swap" ]; then |
| 350 | run_args="${run_args} --dex2oat-swap" |
| 351 | shift |
Andreas Gampe | 4d2ef33 | 2015-08-05 09:24:45 -0700 | [diff] [blame] | 352 | elif [ "x$1" = "x--instruction-set-features" ]; then |
| 353 | shift |
| 354 | run_args="${run_args} --instruction-set-features $1" |
| 355 | shift |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 356 | elif [ "x$1" = "x--bisection-search" ]; then |
| 357 | bisection_search="yes" |
| 358 | shift |
Nicolas Geoffray | b0bbe8e | 2016-11-19 10:42:37 +0000 | [diff] [blame] | 359 | elif [ "x$1" = "x--vdex" ]; then |
| 360 | run_args="${run_args} --vdex" |
| 361 | shift |
Nicolas Geoffray | 7498105 | 2017-01-16 17:54:09 +0000 | [diff] [blame] | 362 | elif [ "x$1" = "x--vdex-filter" ]; then |
| 363 | shift |
| 364 | filter=$1 |
| 365 | run_args="${run_args} --vdex-filter $filter" |
| 366 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 367 | elif expr "x$1" : "x--" >/dev/null 2>&1; then |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 368 | echo "unknown $0 option: $1" 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 369 | usage="yes" |
| 370 | break |
| 371 | else |
| 372 | break |
| 373 | fi |
| 374 | done |
Andreas Gampe | 3a12cfe | 2014-08-13 15:40:22 -0700 | [diff] [blame] | 375 | |
Alex Light | 10bc5a4 | 2016-05-10 10:01:22 -0700 | [diff] [blame] | 376 | run_args="${run_args} ${image_args}" |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 377 | # Allocate file descriptor real_stderr and redirect it to the shell's error |
| 378 | # output (fd 2). |
| 379 | if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then |
| 380 | exec {real_stderr}>&2 |
| 381 | else |
| 382 | # In bash before version 4.1 we need to do a manual search for free file |
| 383 | # descriptors. |
| 384 | FD=3 |
| 385 | while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done |
| 386 | real_stderr=$FD |
| 387 | eval "exec ${real_stderr}>&2" |
| 388 | fi |
| 389 | if [ "$quiet" = "yes" ]; then |
| 390 | # Force the default standard output and error to go to /dev/null so we will |
| 391 | # not print them. |
| 392 | exec 1>/dev/null |
| 393 | exec 2>/dev/null |
| 394 | fi |
| 395 | |
| 396 | function err_echo() { |
| 397 | echo "$@" 1>&${real_stderr} |
| 398 | } |
| 399 | |
Andreas Gampe | 3a12cfe | 2014-08-13 15:40:22 -0700 | [diff] [blame] | 400 | # tmp_dir may be relative, resolve. |
| 401 | # |
| 402 | # Cannot use realpath, as it does not exist on Mac. |
| 403 | # Cannot us a simple "cd", as the path might not be created yet. |
Brian Carlstrom | c580e04 | 2014-09-08 21:37:39 -0700 | [diff] [blame] | 404 | # Cannot use readlink -m, as it does not exist on Mac. |
| 405 | # Fallback to nuclear option: |
Andreas Gampe | 907b699 | 2014-08-18 22:26:49 -0700 | [diff] [blame] | 406 | noncanonical_tmp_dir=$tmp_dir |
Brian Carlstrom | c580e04 | 2014-09-08 21:37:39 -0700 | [diff] [blame] | 407 | tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`" |
Dmitry Petrochenko | 81c56e7 | 2014-03-05 15:05:46 +0700 | [diff] [blame] | 408 | mkdir -p $tmp_dir |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 409 | |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 410 | # Add thread suspend timeout flag |
| 411 | run_args="${run_args} --runtime-option -XX:ThreadSuspendTimeout=$suspend_timeout" |
| 412 | |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 413 | if [ "$basic_verify" = "true" ]; then |
Hiroshi Yamauchi | 312baf1 | 2015-01-12 12:11:05 -0800 | [diff] [blame] | 414 | # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests. |
| 415 | run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 416 | fi |
| 417 | if [ "$gc_verify" = "true" ]; then |
| 418 | run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc" |
| 419 | fi |
| 420 | if [ "$gc_stress" = "true" ]; then |
Mathieu Chartier | d9eb284 | 2016-08-12 16:11:24 -0700 | [diff] [blame] | 421 | run_args="${run_args} --gc-stress --runtime-option -Xgc:gcstress --runtime-option -Xms2m --runtime-option -Xmx16m" |
Alex Light | e7873ec | 2014-08-12 09:53:50 -0700 | [diff] [blame] | 422 | fi |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 423 | if [ "$trace" = "true" ]; then |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 424 | run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000" |
| 425 | if [ "$trace_stream" = "true" ]; then |
| 426 | # Streaming mode uses the file size as the buffer size. So output gets really large. Drop |
| 427 | # the ability to analyze the file and just write to /dev/null. |
| 428 | run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null" |
| 429 | # Enable streaming mode. |
| 430 | run_args="${run_args} --runtime-option -Xmethod-trace-stream" |
| 431 | else |
| 432 | run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin" |
| 433 | fi |
| 434 | elif [ "$trace_stream" = "true" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 435 | err_echo "Cannot use --stream without --trace." |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 436 | exit 1 |
Jeff Hao | 85139a3 | 2014-07-23 11:52:52 -0700 | [diff] [blame] | 437 | fi |
| 438 | |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 439 | # Most interesting target architecture variables are Makefile variables, not environment variables. |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 440 | # Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name. |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 441 | function guess_target_arch_name() { |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 442 | grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'` |
Andreas Gampe | 1a5c406 | 2015-01-15 12:10:47 -0800 | [diff] [blame] | 443 | grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'` |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 444 | if [ "x${suffix64}" = "x64" ]; then |
| 445 | target_arch_name=${grep64bit} |
| 446 | else |
| 447 | target_arch_name=${grep32bit} |
| 448 | fi |
| 449 | } |
| 450 | |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 451 | function guess_host_arch_name() { |
| 452 | if [ "x${suffix64}" = "x64" ]; then |
| 453 | host_arch_name="x86_64" |
| 454 | else |
| 455 | host_arch_name="x86" |
| 456 | fi |
| 457 | } |
| 458 | |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 459 | if [ "$target_mode" = "no" ]; then |
| 460 | if [ "$runtime" = "jvm" ]; then |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 461 | if [ "$prebuild_mode" = "yes" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 462 | err_echo "--prebuild with --jvm is unsupported" |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 463 | exit 1; |
| 464 | fi |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 465 | fi |
| 466 | fi |
| 467 | |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 468 | if [ "$have_patchoat" = "no" ]; then |
| 469 | run_args="${run_args} --no-patchoat" |
| 470 | fi |
| 471 | |
| 472 | if [ "$have_dex2oat" = "no" ]; then |
| 473 | run_args="${run_args} --no-dex2oat" |
| 474 | fi |
| 475 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 476 | if [ ! "$runtime" = "jvm" ]; then |
| 477 | run_args="${run_args} --lib $lib" |
| 478 | fi |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 479 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 480 | if [ "$runtime" = "dalvik" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 481 | if [ "$target_mode" = "no" ]; then |
Nicolas Geoffray | 6fbcc12 | 2014-07-24 00:36:48 +0100 | [diff] [blame] | 482 | framework="${ANDROID_PRODUCT_OUT}/system/framework" |
Andreas Gampe | 50be66f | 2015-12-28 14:31:06 -0800 | [diff] [blame] | 483 | bpath="${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar" |
Richard Uhler | 76f5cb6 | 2016-04-04 13:30:16 -0700 | [diff] [blame] | 484 | run_args="${run_args} --boot --runtime-option -Xbootclasspath:${bpath}" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 485 | else |
| 486 | true # defaults to using target BOOTCLASSPATH |
| 487 | fi |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 488 | elif [ "$runtime" = "art" ]; then |
| 489 | if [ "$target_mode" = "no" ]; then |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 490 | guess_host_arch_name |
Jeff Hao | dcdc85b | 2015-12-04 14:06:18 -0800 | [diff] [blame] | 491 | run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${pic_image_suffix}${multi_image_suffix}.art" |
Colin Cross | afd3c9e | 2016-09-16 13:47:21 -0700 | [diff] [blame] | 492 | run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}:${ANDROID_HOST_OUT}/nativetest${suffix64}" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 493 | else |
David Brazdil | 853a4c3 | 2015-09-28 16:15:50 +0100 | [diff] [blame] | 494 | guess_target_arch_name |
Nicolas Geoffray | f13a365 | 2016-09-22 22:55:58 +0100 | [diff] [blame] | 495 | run_args="${run_args} --runtime-option -Djava.library.path=/data/nativetest${suffix64}/art/${target_arch_name}:${android_root}/lib${suffix64}" |
Jeff Hao | dcdc85b | 2015-12-04 14:06:18 -0800 | [diff] [blame] | 496 | run_args="${run_args} --boot /data/art-test/core${image_suffix}${pic_image_suffix}${multi_image_suffix}.art" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 497 | fi |
Alex Light | a59dd80 | 2014-07-02 16:28:08 -0700 | [diff] [blame] | 498 | if [ "$relocate" = "yes" ]; then |
| 499 | run_args="${run_args} --relocate" |
| 500 | else |
| 501 | run_args="${run_args} --no-relocate" |
| 502 | fi |
Andreas Gampe | 3f1dc56 | 2015-05-18 15:52:22 -0700 | [diff] [blame] | 503 | elif [ "$runtime" = "jvm" ]; then |
| 504 | # TODO: Detect whether the host is 32-bit or 64-bit. |
Alex Light | fba89fe | 2017-01-12 16:11:02 -0800 | [diff] [blame] | 505 | run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64:${ANDROID_HOST_OUT}/nativetest64" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 506 | fi |
| 507 | |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 508 | if [ "$have_image" = "no" ]; then |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 509 | if [ "$runtime" != "art" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 510 | err_echo "--no-image is only supported on the art runtime" |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 511 | exit 1 |
| 512 | fi |
| 513 | if [ "$target_mode" = "no" ]; then |
| 514 | framework="${ANDROID_HOST_OUT}/framework" |
| 515 | bpath_suffix="-hostdex" |
| 516 | else |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 517 | framework="${android_root}/framework" |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 518 | bpath_suffix="" |
| 519 | fi |
| 520 | # TODO If the target was compiled WITH_DEXPREOPT=true then these tests will |
| 521 | # fail since these jar files will be stripped. |
| 522 | bpath="${framework}/core-libart${bpath_suffix}.jar" |
Narayan Kamath | d50687e | 2015-11-17 12:37:27 +0000 | [diff] [blame] | 523 | bpath="${bpath}:${framework}/core-oj${bpath_suffix}.jar" |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 524 | bpath="${bpath}:${framework}/conscrypt${bpath_suffix}.jar" |
| 525 | bpath="${bpath}:${framework}/okhttp${bpath_suffix}.jar" |
Alex Light | 1ef4ce8 | 2014-08-27 11:13:47 -0700 | [diff] [blame] | 526 | bpath="${bpath}:${framework}/bouncycastle${bpath_suffix}.jar" |
| 527 | # Pass down the bootclasspath |
| 528 | run_args="${run_args} --runtime-option -Xbootclasspath:${bpath}" |
Alex Light | 03a112d | 2014-08-25 13:25:56 -0700 | [diff] [blame] | 529 | run_args="${run_args} --no-image" |
| 530 | fi |
| 531 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 532 | if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 533 | err_echo "--dev and --update are mutually exclusive" |
| 534 | usage="yes" |
| 535 | fi |
| 536 | |
| 537 | if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then |
| 538 | err_echo "--dev and --quiet are mutually exclusive" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 539 | usage="yes" |
| 540 | fi |
| 541 | |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 542 | if [ "$bisection_search" = "yes" -a "$prebuild_mode" = "yes" ]; then |
| 543 | err_echo "--bisection-search and --prebuild are mutually exclusive" |
| 544 | usage="yes" |
| 545 | fi |
| 546 | |
| 547 | if [ "$bisection_search" = "yes" -a "$have_dex2oat" = "no" ]; then |
| 548 | err_echo "--bisection-search and --no-dex2oat are mutually exclusive" |
| 549 | usage="yes" |
| 550 | fi |
| 551 | |
| 552 | if [ "$bisection_search" = "yes" -a "$have_patchoat" = "no" ]; then |
| 553 | err_echo "--bisection-search and --no-patchoat are mutually exclusive" |
| 554 | usage="yes" |
| 555 | fi |
| 556 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 557 | if [ "$usage" = "no" ]; then |
| 558 | if [ "x$1" = "x" -o "x$1" = "x-" ]; then |
| 559 | test_dir=`basename "$oldwd"` |
| 560 | else |
| 561 | test_dir="$1" |
| 562 | fi |
| 563 | |
| 564 | if [ '!' -d "$test_dir" ]; then |
| 565 | td2=`echo ${test_dir}-*` |
| 566 | if [ '!' -d "$td2" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 567 | err_echo "${test_dir}: no such test directory" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 568 | usage="yes" |
| 569 | fi |
| 570 | test_dir="$td2" |
| 571 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 572 | # Shift to get rid of the test name argument. The rest of the arguments |
| 573 | # will get passed to the test run. |
| 574 | shift |
| 575 | fi |
| 576 | |
Søren Gjesse | 620d0a5 | 2016-09-19 11:12:51 +0200 | [diff] [blame] | 577 | # For building with javac and dx always use Java 7. The dx compiler |
| 578 | # only support byte codes from Java 7 or earlier (class file major |
| 579 | # version 51 or lower). |
| 580 | if [ "$USE_JACK" != "true" ] && [ "$NEED_DEX" = "true" ]; then |
| 581 | export JAVAC="${JAVAC} -source 1.7 -target 1.7" |
| 582 | fi |
| 583 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 584 | if [ "$usage" = "yes" ]; then |
| 585 | prog=`basename $prog` |
| 586 | ( |
| 587 | echo "usage:" |
| 588 | echo " $prog --help Print this message." |
| 589 | echo " $prog [options] [test-name] Run test normally." |
| 590 | echo " $prog --dev [options] [test-name] Development mode" \ |
| 591 | "(dumps to stdout)." |
| 592 | echo " $prog --update [options] [test-name] Update mode" \ |
| 593 | "(replaces expected.txt)." |
| 594 | echo ' Omitting the test name or specifying "-" will use the' \ |
| 595 | "current directory." |
| 596 | echo " Runtime Options:" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 597 | echo " -O Run non-debug rather than debug build (off by default)." |
| 598 | echo " -Xcompiler-option Pass an option to the compiler." |
| 599 | echo " --runtime-option Pass an option to the runtime." |
| 600 | echo " --debug Wait for a debugger to attach." |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 601 | echo " --debuggable Whether to compile Java code for a debugger." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 602 | echo " --gdb Run under gdb; incompatible with some tests." |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 603 | echo " --gdb-arg Pass an option to gdb." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 604 | echo " --build-only Build test files only (off by default)." |
Søren Gjesse | 620d0a5 | 2016-09-19 11:12:51 +0200 | [diff] [blame] | 605 | echo " --build-with-javac-dx Build test files with javac and dx (off by default)." |
| 606 | echo " --build-with-jack Build test files with jack and jill (on by default)." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 607 | echo " --interpreter Enable interpreter only mode (off by default)." |
Mathieu Chartier | e5f13e5 | 2015-02-24 09:37:21 -0800 | [diff] [blame] | 608 | echo " --jit Enable jit (off by default)." |
Nicolas Geoffray | 0e07125 | 2015-03-21 13:43:15 +0000 | [diff] [blame] | 609 | echo " --optimizing Enable optimizing compiler (default)." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 610 | echo " --no-verify Turn off verification (on by default)." |
Igor Murashkin | 7617abd | 2015-07-10 18:27:47 -0700 | [diff] [blame] | 611 | echo " --verify-soft-fail Force soft fail verification (off by default)." |
| 612 | echo " Verification is enabled if neither --no-verify" |
| 613 | echo " nor --verify-soft-fail is specified." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 614 | echo " --no-optimize Turn off optimization (on by default)." |
| 615 | echo " --no-precise Turn off precise GC (on by default)." |
| 616 | echo " --zygote Spawn the process from the Zygote." \ |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 617 | "If used, then the" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 618 | echo " other runtime options are ignored." |
| 619 | echo " --no-dex2oat Run as though dex2oat was failing." |
| 620 | echo " --no-patchoat Run as though patchoat was failing." |
| 621 | echo " --prebuild Run dex2oat on the files before starting test. (default)" |
| 622 | echo " --no-prebuild Do not run dex2oat on the files before starting" |
| 623 | echo " the test." |
Richard Uhler | 76f5cb6 | 2016-04-04 13:30:16 -0700 | [diff] [blame] | 624 | echo " --strip-dex Strip the dex files before starting test." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 625 | echo " --relocate Force the use of relocating in the test, making" |
| 626 | echo " the image and oat files be relocated to a random" |
| 627 | echo " address before running. (default)" |
| 628 | echo " --no-relocate Force the use of no relocating in the test" |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 629 | echo " --image Run the test using a precompiled boot image. (default)" |
| 630 | echo " --no-image Run the test without a precompiled boot image." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 631 | echo " --host Use the host-mode virtual machine." |
| 632 | echo " --invoke-with Pass --invoke-with option to runtime." |
| 633 | echo " --dalvik Use Dalvik (off by default)." |
| 634 | echo " --jvm Use a host-local RI virtual machine." |
Alex Light | eb7c144 | 2015-08-31 13:17:42 -0700 | [diff] [blame] | 635 | echo " --use-java-home Use the JAVA_HOME environment variable" |
| 636 | echo " to find the java compiler and runtime" |
| 637 | echo " (if applicable) to run the test with." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 638 | echo " --output-path [path] Location where to store the build" \ |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 639 | "files." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 640 | echo " --64 Run the test in 64-bit mode" |
| 641 | echo " --trace Run with method tracing" |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 642 | echo " --strace Run with syscall tracing from strace." |
Andreas Gampe | 7526d78 | 2015-06-22 22:53:45 -0700 | [diff] [blame] | 643 | echo " --stream Run method tracing in streaming mode (requires --trace)" |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 644 | echo " --gcstress Run with gc stress testing" |
| 645 | echo " --gcverify Run with gc verification" |
| 646 | echo " --always-clean Delete the test files even if the test fails." |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 647 | echo " --never-clean Keep the test files even if the test succeeds." |
Nicolas Geoffray | c8f23fc | 2014-10-28 17:59:47 +0000 | [diff] [blame] | 648 | echo " --android-root [path] The path on target for the android root. (/system by default)." |
Nicolas Geoffray | 43c162f | 2015-03-09 12:21:26 +0000 | [diff] [blame] | 649 | echo " --dex2oat-swap Use a dex2oat swap file." |
Andreas Gampe | 4d2ef33 | 2015-08-05 09:24:45 -0700 | [diff] [blame] | 650 | echo " --instruction-set-features [string]" |
| 651 | echo " Set instruction-set-features for compilation." |
Nicolas Geoffray | b76bc78 | 2016-09-14 12:33:34 +0000 | [diff] [blame] | 652 | echo " --npic-image Use an image compiled with non-position independent code " |
| 653 | echo " for the boot class path." |
Jeff Hao | dcdc85b | 2015-12-04 14:06:18 -0800 | [diff] [blame] | 654 | echo " --multi-image Use a set of images compiled with dex2oat multi-image for" |
| 655 | echo " the boot class path." |
Alex Light | fadfee9 | 2015-10-28 09:40:10 -0700 | [diff] [blame] | 656 | echo " --pic-test Compile the test code position independent." |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 657 | echo " --quiet Don't print anything except failure messages" |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 658 | echo " --bisection-search Perform bisection bug search." |
Nicolas Geoffray | b0bbe8e | 2016-11-19 10:42:37 +0000 | [diff] [blame] | 659 | echo " --vdex Test using vdex as in input to dex2oat. Only works with --prebuild." |
Mathieu Chartier | 3fceaf5 | 2017-01-22 13:33:40 -0800 | [diff] [blame] | 660 | echo " --suspend-timeout Change thread suspend timeout ms (default 500000)." |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 661 | ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set. |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 662 | exit 1 |
| 663 | fi |
| 664 | |
| 665 | cd "$test_dir" |
| 666 | test_dir=`pwd` |
| 667 | |
| 668 | td_info="${test_dir}/${info}" |
| 669 | td_expected="${test_dir}/${expected}" |
| 670 | |
Brian Carlstrom | 22469aa | 2012-09-07 10:34:57 -0700 | [diff] [blame] | 671 | if [ ! -r $td_info ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 672 | err_echo "${test_dir}: missing file $td_info" |
Brian Carlstrom | 22469aa | 2012-09-07 10:34:57 -0700 | [diff] [blame] | 673 | exit 1 |
| 674 | fi |
| 675 | |
| 676 | if [ ! -r $td_expected ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 677 | err_echo "${test_dir}: missing file $td_expected" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 678 | exit 1 |
| 679 | fi |
| 680 | |
| 681 | # copy the test to a temp dir and run it |
| 682 | |
Elliott Hughes | 510c878 | 2011-10-06 10:57:34 -0700 | [diff] [blame] | 683 | echo "${test_dir}: building..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 684 | |
| 685 | rm -rf "$tmp_dir" |
| 686 | cp -Rp "$test_dir" "$tmp_dir" |
| 687 | cd "$tmp_dir" |
| 688 | |
| 689 | if [ '!' -r "$build" ]; then |
| 690 | cp "${progdir}/etc/default-build" build |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 691 | else |
| 692 | cp "${progdir}/etc/default-build" . |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 693 | fi |
| 694 | |
| 695 | if [ '!' -r "$run" ]; then |
| 696 | cp "${progdir}/etc/default-run" run |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 697 | else |
| 698 | cp "${progdir}/etc/default-run" . |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 699 | fi |
| 700 | |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 701 | if [ '!' -r "$check_cmd" ]; then |
| 702 | cp "${progdir}/etc/default-check" check |
Zheng Xu | c666710 | 2015-05-15 16:08:45 +0800 | [diff] [blame] | 703 | else |
| 704 | cp "${progdir}/etc/default-check" . |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 705 | fi |
| 706 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 707 | chmod 755 "$build" |
| 708 | chmod 755 "$run" |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 709 | chmod 755 "$check_cmd" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 710 | |
Elliott Hughes | 8cbc8bc | 2011-10-04 11:19:45 -0700 | [diff] [blame] | 711 | export TEST_NAME=`basename ${test_dir}` |
| 712 | |
Roland Levillain | 0d5a281 | 2015-11-13 10:07:31 +0000 | [diff] [blame] | 713 | # arch_supports_read_barrier ARCH |
| 714 | # ------------------------------- |
| 715 | # Return whether the Optimizing compiler has read barrier support for ARCH. |
| 716 | function arch_supports_read_barrier() { |
Roland Levillain | 22ccc3a | 2015-11-24 13:10:05 +0000 | [diff] [blame] | 717 | # Optimizing has read barrier support for ARM, ARM64, x86 and x86-64 at the |
Roland Levillain | 0d5a281 | 2015-11-13 10:07:31 +0000 | [diff] [blame] | 718 | # moment. |
Roland Levillain | 22ccc3a | 2015-11-24 13:10:05 +0000 | [diff] [blame] | 719 | [ "x$1" = xarm ] || [ "x$1" = xarm64 ] || [ "x$1" = xx86 ] || [ "x$1" = xx86_64 ] |
Roland Levillain | 0d5a281 | 2015-11-13 10:07:31 +0000 | [diff] [blame] | 720 | } |
| 721 | |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 722 | # Tests named '<number>-checker-*' will also have their CFGs verified with |
| 723 | # Checker when compiled with Optimizing on host. |
| 724 | if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then |
Nicolas Geoffray | b76bc78 | 2016-09-14 12:33:34 +0000 | [diff] [blame] | 725 | if [ "$runtime" = "art" -a "$image_suffix" = "" -a "$USE_JACK" = "true" ]; then |
Roland Levillain | 0d5a281 | 2015-11-13 10:07:31 +0000 | [diff] [blame] | 726 | # Optimizing has read barrier support for certain architectures |
| 727 | # only. On other architectures, compiling is disabled when read |
| 728 | # barriers are enabled, meaning that we do not produce a CFG file |
| 729 | # as a side-effect of compilation, thus the Checker assertions |
| 730 | # cannot be checked. Disable Checker for those cases. |
| 731 | # |
| 732 | # TODO: Enable Checker when read barrier support is added to more |
| 733 | # architectures (b/12687968). |
Hiroshi Yamauchi | fd3161a | 2017-01-18 14:47:25 -0800 | [diff] [blame] | 734 | if [ "x$ART_USE_READ_BARRIER" != xfalse ] \ |
Roland Levillain | 0d5a281 | 2015-11-13 10:07:31 +0000 | [diff] [blame] | 735 | && (([ "x$host_mode" = "xyes" ] \ |
| 736 | && ! arch_supports_read_barrier "$host_arch_name") \ |
| 737 | || ([ "x$target_mode" = "xyes" ] \ |
| 738 | && ! arch_supports_read_barrier "$target_arch_name")); then |
| 739 | run_checker="no" |
David Brazdil | 80fb394 | 2015-07-23 11:53:42 +0100 | [diff] [blame] | 740 | # In no-prebuild mode, the compiler is only invoked if both dex2oat and |
| 741 | # patchoat are available. Disable Checker otherwise (b/22552692). |
Roland Levillain | 0d5a281 | 2015-11-13 10:07:31 +0000 | [diff] [blame] | 742 | elif [ "$prebuild_mode" = "yes" ] \ |
| 743 | || [ "$have_patchoat" = "yes" -a "$have_dex2oat" = "yes" ]; then |
David Brazdil | 80fb394 | 2015-07-23 11:53:42 +0100 | [diff] [blame] | 744 | run_checker="yes" |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 745 | |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 746 | if [ "$target_mode" = "no" ]; then |
| 747 | cfg_output_dir="$tmp_dir" |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 748 | checker_args="--arch=${host_arch_name^^}" |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 749 | else |
| 750 | cfg_output_dir="$DEX_LOCATION" |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 751 | checker_args="--arch=${target_arch_name^^}" |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 752 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 753 | |
| 754 | if [ "$debuggable" = "yes" ]; then |
| 755 | checker_args="$checker_args --debuggable" |
| 756 | fi |
| 757 | |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 758 | run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \ |
David Brazdil | 80fb394 | 2015-07-23 11:53:42 +0100 | [diff] [blame] | 759 | -Xcompiler-option -j1" |
| 760 | fi |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 761 | fi |
| 762 | fi |
| 763 | |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 764 | run_args="${run_args} --testlib ${testlib}" |
Mathieu Chartier | 031768a | 2015-08-27 10:25:02 -0700 | [diff] [blame] | 765 | |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 766 | # To cause tests to fail fast, limit the file sizes created by dx, dex2oat and ART output to 2MB. |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 767 | build_file_size_limit=2048 |
| 768 | run_file_size_limit=2048 |
Alex Light | 4694e82 | 2016-01-22 10:09:40 -0800 | [diff] [blame] | 769 | |
| 770 | # Add tests requiring a higher ulimit to this list. Ulimits might need to be raised to deal with |
| 771 | # large amounts of expected output or large generated files. |
| 772 | if echo "$test_dir" | grep -Eq "(083|089|961|964|971)" > /dev/null; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 773 | build_file_size_limit=5120 |
| 774 | run_file_size_limit=5120 |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 775 | fi |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 776 | if [ "$run_checker" = "yes" -a "$target_mode" = "yes" ]; then |
| 777 | # We will need to `adb pull` the .cfg output from the target onto the host to |
| 778 | # run checker on it. This file can be big. |
Nicolas Geoffray | 4151eff | 2016-11-06 14:24:08 +0000 | [diff] [blame] | 779 | build_file_size_limit=32768 |
| 780 | run_file_size_limit=32768 |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 781 | fi |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 782 | if [ ${USE_JACK} = "false" ]; then |
| 783 | # Set ulimit if we build with dx only, Jack can generate big temp files. |
| 784 | if ! ulimit -S "$build_file_size_limit"; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 785 | err_echo "ulimit file size setting failed" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 786 | fi |
Ian Rogers | 997f0f9 | 2014-06-21 22:58:05 -0700 | [diff] [blame] | 787 | fi |
| 788 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 789 | good="no" |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 790 | good_build="yes" |
| 791 | good_run="yes" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 792 | if [ "$dev_mode" = "yes" ]; then |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 793 | "./${build}" $build_args 2>&1 |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 794 | build_exit="$?" |
| 795 | echo "build exit status: $build_exit" 1>&2 |
| 796 | if [ "$build_exit" = '0' ]; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 797 | if ! ulimit -S "$run_file_size_limit"; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 798 | err_echo "ulimit file size setting failed" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 799 | fi |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 800 | echo "${test_dir}: running..." 1>&2 |
| 801 | "./${run}" $run_args "$@" 2>&1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 802 | run_exit="$?" |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 803 | |
Brian Carlstrom | 700c8d3 | 2012-11-05 10:42:02 -0800 | [diff] [blame] | 804 | if [ "$run_exit" = "0" ]; then |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 805 | if [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 806 | if [ "$target_mode" = "yes" ]; then |
| 807 | adb pull $cfg_output_dir/$cfg_output &> /dev/null |
| 808 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 809 | "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1 |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 810 | checker_exit="$?" |
| 811 | if [ "$checker_exit" = "0" ]; then |
| 812 | good="yes" |
| 813 | fi |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 814 | err_echo "checker exit status: $checker_exit" |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 815 | else |
| 816 | good="yes" |
| 817 | fi |
Brian Carlstrom | 700c8d3 | 2012-11-05 10:42:02 -0800 | [diff] [blame] | 818 | fi |
Calin Juravle | 3cf4877 | 2015-01-26 16:47:33 +0000 | [diff] [blame] | 819 | echo "run exit status: $run_exit" 1>&2 |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 820 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 821 | elif [ "$update_mode" = "yes" ]; then |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 822 | "./${build}" $build_args >"$build_output" 2>&1 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 823 | build_exit="$?" |
| 824 | if [ "$build_exit" = '0' ]; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 825 | if ! ulimit -S "$run_file_size_limit"; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 826 | err_echo "ulimit file size setting failed" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 827 | fi |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 828 | echo "${test_dir}: running..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 829 | "./${run}" $run_args "$@" >"$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 830 | if [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 831 | if [ "$target_mode" = "yes" ]; then |
| 832 | adb pull $cfg_output_dir/$cfg_output &> /dev/null |
| 833 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 834 | "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 835 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 836 | sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}" |
| 837 | good="yes" |
| 838 | else |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 839 | cat "$build_output" 1>&${real_stderr} 1>&2 |
| 840 | err_echo "build exit status: $build_exit" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 841 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 842 | elif [ "$build_only" = "yes" ]; then |
| 843 | good="yes" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 844 | "./${build}" $build_args >"$build_output" 2>&1 |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 845 | build_exit="$?" |
| 846 | if [ "$build_exit" '!=' '0' ]; then |
| 847 | cp "$build_output" "$output" |
| 848 | echo "build exit status: $build_exit" >>"$output" |
| 849 | diff --strip-trailing-cr -q "$expected" "$output" >/dev/null |
| 850 | if [ "$?" '!=' "0" ]; then |
| 851 | good="no" |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 852 | err_echo "BUILD FAILED For ${TEST_NAME}" |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 853 | fi |
| 854 | fi |
Tsu Chiang Chuang | 379e2f5 | 2013-08-20 12:24:52 -0700 | [diff] [blame] | 855 | # Clean up extraneous files that are not used by tests. |
Tsu Chiang Chuang | 0160d99 | 2013-09-13 14:17:42 -0700 | [diff] [blame] | 856 | find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 857 | exit 0 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 858 | else |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 859 | "./${build}" $build_args >"$build_output" 2>&1 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 860 | build_exit="$?" |
| 861 | if [ "$build_exit" = '0' ]; then |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 862 | if ! ulimit -S "$run_file_size_limit"; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 863 | err_echo "ulimit file size setting failed" |
Sebastien Hertz | 19ac027 | 2015-02-24 17:39:50 +0100 | [diff] [blame] | 864 | fi |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 865 | echo "${test_dir}: running..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 866 | "./${run}" $run_args "$@" >"$output" 2>&1 |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 867 | run_exit="$?" |
| 868 | if [ "$run_exit" != "0" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 869 | err_echo "run exit status: $run_exit" |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 870 | good_run="no" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 871 | elif [ "$run_checker" = "yes" ]; then |
Alexandre Rames | 5e2c8d3 | 2015-08-06 14:49:28 +0100 | [diff] [blame] | 872 | if [ "$target_mode" = "yes" ]; then |
| 873 | adb pull $cfg_output_dir/$cfg_output &> /dev/null |
| 874 | fi |
David Brazdil | 5cc343d | 2015-10-08 11:35:32 +0100 | [diff] [blame] | 875 | "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1 |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 876 | checker_exit="$?" |
| 877 | if [ "$checker_exit" != "0" ]; then |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 878 | err_echo "checker exit status: $checker_exit" |
David Brazdil | 4846d13 | 2015-01-15 19:07:08 +0000 | [diff] [blame] | 879 | good_run="no" |
| 880 | else |
| 881 | good_run="yes" |
| 882 | fi |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 883 | else |
| 884 | good_run="yes" |
| 885 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 886 | else |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 887 | good_build="no" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 888 | cp "$build_output" "$output" |
Andreas Gampe | f6930a8 | 2014-10-21 09:33:08 -0700 | [diff] [blame] | 889 | echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output" |
| 890 | echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output" |
Ian Rogers | d9ad27d | 2014-10-27 13:48:21 -0700 | [diff] [blame] | 891 | echo "Args: ${args}" >> "$output" |
Andreas Gampe | f6930a8 | 2014-10-21 09:33:08 -0700 | [diff] [blame] | 892 | echo "build exit status: $build_exit" >> "$output" |
Andreas Gampe | 5c11490 | 2014-10-27 17:03:58 -0700 | [diff] [blame] | 893 | max_name_length=$(getconf NAME_MAX ${tmp_dir}) |
| 894 | echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output" |
| 895 | max_path_length=$(getconf PATH_MAX ${tmp_dir}) |
Andreas Gampe | 602fbcd | 2014-10-27 17:06:29 -0700 | [diff] [blame] | 896 | echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 897 | fi |
Andreas Gampe | 1c83cbc | 2014-07-22 18:52:29 -0700 | [diff] [blame] | 898 | ./$check_cmd "$expected" "$output" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 899 | if [ "$?" = "0" ]; then |
Nicolas Geoffray | 1ed097d | 2014-11-13 15:15:39 +0000 | [diff] [blame] | 900 | if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then |
| 901 | # output == expected |
| 902 | good="yes" |
| 903 | echo "${test_dir}: succeeded!" 1>&2 |
| 904 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 905 | fi |
| 906 | fi |
| 907 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 908 | ( |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 909 | if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 910 | echo "${test_dir}: FAILED!" |
| 911 | echo ' ' |
| 912 | echo '#################### info' |
| 913 | cat "${td_info}" | sed 's/^/# /g' |
| 914 | echo '#################### diffs' |
Hiroshi Yamauchi | d630fd6 | 2015-09-04 12:52:03 -0700 | [diff] [blame] | 915 | diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 916 | echo '####################' |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 917 | if [ "$strace" = "yes" ]; then |
| 918 | echo '#################### strace output' |
Hiroshi Yamauchi | d630fd6 | 2015-09-04 12:52:03 -0700 | [diff] [blame] | 919 | tail -n 3000 "$tmp_dir/$strace_output" |
Hiroshi Yamauchi | 1d4184d | 2015-07-13 17:11:22 -0700 | [diff] [blame] | 920 | echo '####################' |
| 921 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 922 | echo ' ' |
| 923 | fi |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 924 | |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 925 | ) 2>&${real_stderr} 1>&2 |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 926 | |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 927 | # Attempt bisection only if the test failed. |
| 928 | if [ "$bisection_search" = "yes" -a "$good" != "yes" ]; then |
| 929 | # Bisecting works by skipping different optimization passes which breaks checker assertions. |
| 930 | if [ "$run_checker" == "yes" ]; then |
| 931 | echo "${test_dir}: not bisecting, checker test." 1>&2 |
| 932 | else |
| 933 | # Increase file size limit, bisection search can generate large logfiles. |
| 934 | if ! ulimit -S unlimited; then |
| 935 | err_echo "ulimit file size setting failed" |
| 936 | fi |
| 937 | echo "${test_dir}: bisecting..." 1>&2 |
| 938 | cwd=`pwd` |
| 939 | maybe_device_mode="" |
| 940 | raw_cmd="" |
| 941 | if [ "$target_mode" = "yes" ]; then |
| 942 | # Produce cmdline.sh in $DEX_LOCATION. "$@" is passed as a runtime option |
| 943 | # so that cmdline.sh forwards its arguments to dalvikvm. invoke-with is set |
| 944 | # to exec in order to preserve pid when calling dalvikvm. This is required |
| 945 | # for bisection search to correctly retrieve logs from device. |
| 946 | "./${run}" $run_args --runtime-option '"$@"' --invoke-with exec --dry-run "$@" &> /dev/null |
| 947 | adb shell chmod u+x "$DEX_LOCATION/cmdline.sh" |
| 948 | maybe_device_mode="--device" |
| 949 | raw_cmd="$DEX_LOCATION/cmdline.sh" |
| 950 | else |
| 951 | raw_cmd="$cwd/${run} --external-log-tags $run_args $@" |
| 952 | fi |
| 953 | $ANDROID_BUILD_TOP/art/tools/bisection_search/bisection_search.py \ |
| 954 | $maybe_device_mode \ |
| 955 | --raw-cmd="$raw_cmd" \ |
| 956 | --check-script="$cwd/check" \ |
| 957 | --expected-output="$cwd/expected.txt" \ |
Wojciech Staszkiewicz | 0c88383 | 2016-09-26 17:51:52 -0700 | [diff] [blame] | 958 | --logfile="$cwd/bisection_log.txt" \ |
Wojciech Staszkiewicz | d7a819a | 2016-09-01 14:43:39 -0700 | [diff] [blame] | 959 | --timeout=300 |
| 960 | fi |
| 961 | fi |
| 962 | |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 963 | # Clean up test files. |
Igor Murashkin | 05f30e1 | 2015-06-10 15:57:17 -0700 | [diff] [blame] | 964 | if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then |
Alex Light | bfac14a | 2014-07-30 09:41:21 -0700 | [diff] [blame] | 965 | cd "$oldwd" |
| 966 | rm -rf "$tmp_dir" |
| 967 | if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then |
| 968 | adb shell rm -rf $DEX_LOCATION |
| 969 | fi |
| 970 | if [ "$good" = "yes" ]; then |
| 971 | exit 0 |
| 972 | fi |
| 973 | fi |
| 974 | |
| 975 | |
| 976 | ( |
| 977 | if [ "$always_clean" = "yes" ]; then |
| 978 | echo "${TEST_NAME} files deleted from host " |
| 979 | if [ "$target_mode" == "yes" ]; then |
| 980 | echo "and from target" |
| 981 | fi |
| 982 | else |
| 983 | echo "${TEST_NAME} files left in ${tmp_dir} on host" |
| 984 | if [ "$target_mode" == "yes" ]; then |
| 985 | echo "and in ${DEX_LOCATION} on target" |
| 986 | fi |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 987 | fi |
| 988 | |
Alex Light | 91de25f | 2015-10-28 17:00:06 -0700 | [diff] [blame] | 989 | ) 2>&${real_stderr} 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 990 | |
Alex Light | 6a870fa | 2016-05-31 16:36:19 -0700 | [diff] [blame] | 991 | if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then |
| 992 | exit 0 |
| 993 | else |
| 994 | exit 1 |
| 995 | fi |